//////////////////////////////////////////////////////////////////////////////////////////////////
events_Holder

	//============================================================================================
	var
		list
			events_adds		//	adds[Trigger][Trigger][Event][Source] = Argument

	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	During Trigger, Source adds AddedEvent to happen during AddTrigger.
		//	Returns FALSE if the addition was already listed.
		events_AddEventAddition(Source, \
			events_Trigger/Trigger,events_Event/AddedEvent,events_Trigger/AddTrigger,Argument)
			if ( isnull(Source) || isnull(Trigger) || isnull(AddedEvent)  || isnull(AddTrigger) )
				return FALSE

			if ( isnull(src.events_adds) )
				src.events_adds	= list()
			if ( !(Trigger in src.events_adds) )
				src.events_adds[Trigger]	= list()
			if ( !(AddTrigger in src.events_adds[Trigger]) )
				src.events_adds[Trigger][AddTrigger]	= list()
			if ( !(AddedEvent in src.events_adds[Trigger][AddTrigger]) )
				src.events_adds[Trigger][AddTrigger][AddedEvent]	= list()
			if ( !(Source in src.events_adds[Trigger][AddTrigger][AddedEvent]) )
				src.events_adds[Trigger][AddTrigger][AddedEvent][Source]	= Argument
				return TRUE

			//return TRUE
			return FALSE

		//----------------------------------------------------------------------------------------
		//	Returns what Source adds during Trigger.
		//	The result is a list of events_Triggers associated with events_Events associated with arguments.
		events_GetAdditions(Source,events_Trigger/Trigger)
			if ( isnull(Source) || isnull(Trigger) )	return list()
			if ( !(Trigger in src.events_adds) )		return list()

			var
				results		= list()
				AddedEvent
				AddTrigger
			for(AddTrigger in src.events_adds[Trigger])
				for(AddedEvent in src.events_adds[Trigger][AddTrigger])
					if (Source in src.events_adds[Trigger][AddTrigger][AddedEvent])
						if ( !(AddTrigger in results) )
							results[AddTrigger]			= list()
						results[AddTrigger][AddedEvent]	= src.events_adds[Trigger][AddTrigger][AddedEvent][Source]

			return results

		//----------------------------------------------------------------------------------------
		//	Get argument Source uses when adding Event for AddTrigger during Trigger.
		events_GetAdditionArgument(Source, \
			events_Trigger/Trigger,events_Event/AddedEvent,events_Trigger/AddTrigger)
			if ( !src.events_HasAddition(Source,Trigger,AddedEvent,AddTrigger) )	return null
			return src.events_adds[Trigger][AddTrigger][AddedEvent][Source]

		//----------------------------------------------------------------------------------------
		//	Returns whether or not Source, during Trigger, will add Event to occur during AddTrigger.
		events_HasAddition(Source, \
			events_Trigger/Trigger,events_Event/AddedEvent,events_Trigger/AddTrigger)
			if ( isnull(Source) || isnull(Trigger) || isnull(AddedEvent)  || isnull(AddTrigger) )
				return FALSE
			if ( isnull(src.events_adds) )									return FALSE
			if ( !(Trigger in src.events_adds) )							return FALSE
			if ( !(AddTrigger in src.events_adds[Trigger]) )				return FALSE
			if ( !(AddedEvent in src.events_adds[Trigger][AddTrigger]) )	return FALSE

			return (Source in src.events_adds[Trigger][AddTrigger][AddedEvent])

		//----------------------------------------------------------------------------------------
		//	During Trigger, Source no longer adds AddedEvent to happen during AddTrigger.
		//	Returns TRUE only if the removal occured.
		//	(If it was not there in the first place then it returns FALSE.)
		//	Argument is passed in, but does nothing by default.
		events_RemoveEventAddition(Source, \
			events_Trigger/Trigger,events_Event/AddedEvent,events_Trigger/AddTrigger,Argument)
			if ( isnull(Source) || isnull(Trigger) || isnull(AddedEvent)  || isnull(AddTrigger) )
				return FALSE
			if ( isnull(src.events_adds) )											return FALSE
			if ( !(Trigger in src.events_adds) )									return FALSE
			if ( !(AddTrigger in src.events_adds[Trigger]) )						return FALSE
			if ( !(AddedEvent in src.events_adds[Trigger][AddTrigger]) )			return FALSE
			if ( !(Source in src.events_adds[Trigger][AddTrigger][AddedEvent]) )	return FALSE

			src.events_adds[Trigger][AddTrigger][AddedEvent]	-= Source

			if ( !length(src.events_adds[Trigger][AddTrigger][AddedEvent]) )
				src.events_adds[Trigger][AddTrigger]			-= AddedEvent
			if ( !length(src.events_adds[Trigger][AddTrigger]) )
				src.events_adds[Trigger]						-= AddTrigger
			if ( !length(src.events_adds[Trigger]) )
				src.events_adds									-= Trigger
			if ( !length(src.events_adds) )
				src.events_adds									-= null

			return TRUE

//////////////////////////////////////////////////////////////////////////////////////////////////