//////////////////////////////////////////////////////////////////////////////////////////////////
events_Holder

	//============================================================================================
	var
		list
			events_events		//	events[Trigger][Event][Source]	= Argument

	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	Source should now have Event occur during Trigger.
		//	Returns FALSE if it was already listed.
		events_AddEvent(Source,events_Trigger/Trigger,events_Event/Event,Argument,\
			events_Trigger/Caller=null,CallerSource=null)

			if ( isnull(Source) || isnull(Trigger) || isnull(Event) )
				return FALSE

			if ( isnull(src.events_events) )
				src.events_events	= list()
			if ( !(Trigger in src.events_events) )
				src.events_events[Trigger]	= list()
			if ( !(Event in src.events_events[Trigger]) )
				src.events_events[Trigger][Event]	= list()
			if ( !(Source in src.events_events[Trigger][Event]) )
				src.events_events[Trigger][Event][Source] = Argument
				return TRUE

			//return TRUE
			return FALSE

		//----------------------------------------------------------------------------------------
		//	Returns a list of events_Events (associated with arguments)
		//	which occur when Trigger happens with Source.
		events_GetEvents(Source,events_Trigger/Trigger)
			if ( isnull(Source) || isnull(Trigger) )
				return list()
			if ( !(Trigger in src.events_events) )
				return list()

			var/results	= list()
			for(var/Event in src.events_events[Trigger])
				if (Source in src.events_events[Trigger][Event])
					results[Event]	= src.events_events[Trigger][Event][Source]

			return results

		//----------------------------------------------------------------------------------------
		//	Get the argument Source uses when calling Event during Trigger.
		events_GetEventArgument(Source,events_Trigger/Trigger,events_Event/Event)
			if ( !src.events_HasEvent(Source,Trigger,Event) )	return null
			return src.events_events[Trigger][Event][Source]

		//----------------------------------------------------------------------------------------
		//	Returns whether or not Source has Event during Trigger.
		events_HasEvent(Source,events_Trigger/Trigger,events_Event/Event)
			if ( isnull(Source) || isnull(Trigger) || isnull(Event) )
				return FALSE
			if ( isnull(src.events_events) )
				return FALSE
			if ( !(Trigger in src.events_events) )
				return FALSE
			if ( !(Event in src.events_events[Trigger]) )
				return FALSE

			return (Source in src.events_events[Trigger][Event])

		//----------------------------------------------------------------------------------------
		//	Source no longer has Event occur during Trigger.
		//	Returns TRUE only if the event was indeed removed.
		//	(If it was not there in the first place then it returns FALSE.)
		//	By default, Argument is passed in but ignored.
		events_RemoveEvent(Source,events_Trigger/Trigger,events_Event/Event,Argument,\
			events_Trigger/Caller=null,CallerSource=null)

			if ( isnull(Source) || isnull(Trigger) || isnull(Event) )
				return FALSE
			if ( isnull(src.events_events) )
				return FALSE
			if ( !(Trigger in src.events_events) )
				return FALSE
			if ( !(Event in src.events_events[Trigger]) )
				return FALSE
			if ( !(Source in src.events_events[Trigger][Event]) )
				return FALSE

			src.events_events[Trigger][Event]	-= Source

			if ( !length(src.events_events[Trigger][Event]) )
				src.events_events[Trigger]		-= Event
			if ( !length(src.events_events[Trigger][Event]) )
				src.events_events[Trigger]		-= Event
			if ( !length(src.events_events[Trigger]) )
				src.events_events				-= Trigger
			if ( !length(src.events_events) )
				src.events_events				= null

			return TRUE

//////////////////////////////////////////////////////////////////////////////////////////////////