//////////////////////////////////////////////////////////////////////////////////////////////////
events_Trigger

	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	Target triggered this for Source.
		//	Holder knows what Source does to targets.
		//	This events_Trigger tells the proper events to perform.
		//	Next, Holder is told to make the proper event removals.
		//	Finally, Holder is told to make the proper event additions.
		events_Triggered(events_Holder/Holder,Source,Target)
			src.events_TriggeredEvents(Holder,Source,Target)
			src.events_TriggeredRemovals(Holder,Source,Target)
			src.events_TriggeredAdditions(Holder,Source,Target)

		//----------------------------------------------------------------------------------------
		events_TriggeredAdditions(events_Holder/Holder,Source,Target)
			if ( isnull(Holder) || isnull(Source) || isnull(Target) )
				return

			var
				events_Event/E
				events_Trigger/T
				additions			= Holder.events_GetAdditions(Source,src)
			for(T in additions)
				for(E in additions[T])
					Holder.events_AddEvent(Target,T,E,,additions[T][E],src,Source)

		//----------------------------------------------------------------------------------------
		events_TriggeredEvents(events_Holder/Holder,Source,Target)
			if ( isnull(Holder) || isnull(Source) || isnull(Target) )
				return

			var
				list/events	= Holder.events_GetEvents(Source,src)
				events_Event/E
			for(E in events)
				E.events_Perform(Holder,src,Source,Target,events[E])

		//----------------------------------------------------------------------------------------
		events_TriggeredRemovals(events_Holder/Holder,Source,Target)
			if ( isnull(Holder) || isnull(Source) || isnull(Target) )
				return

			var
				events_Event/E
				events_Trigger/T
				removals			= Holder.events_GetRemovals(Source,src)
			for(T in removals)
				for(E in removals[T])
					Holder.events_RemoveEvent(Target,T,E,removals[T][E],src,Source)

//////////////////////////////////////////////////////////////////////////////////////////////////